########################################################################
#  Indiana University Opie Lab Software License, Version 1.2
#
#  Copyright (C) 2002 The Trustees of Indiana University.
#  All rights reserved.
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are
#  met:
#
#  1) All redistributions of source code must retain the above
#     copyright notice, the list of authors in the original source
#     code, this list of conditions and the disclaimer listed in this
#     license;
#
#  2) All redistributions in binary form must reproduce the above
#     copyright notice, this list of conditions and the disclaimer
#     listed in this license in the documentation and/or other
#     materials provided with the distribution;
#
#  3) Any documentation included with all redistributions must include
#     the following acknowledgement:
#
#       "This product includes software developed by the Indiana
#       University Opie Lab.  For further information please visit
#       http://www.cs.indiana.edu/~dswise"
#
#     Alternatively, this acknowledgment may appear in the software
#     itself, and wherever such third-party acknowledgments normally
#     appear.
#
#  4) The name "Indiana University" or "Indiana University
#     Opie Lab" shall not be used to endorse or promote
#     products derived from this software without prior written
#     permission from Indiana University.  For written permission,
#     please contact http://www.cs.indiana.edu/~dswise.
#
#  5) Products derived from this software may not use "Indiana
#     University" name nor may "Indiana University" appear in their name,
#     without prior written permission of the Indiana University.
#
#  Indiana University provides no reassurances that the source code
#  provided does not infringe the patent or any other intellectual
#  property rights of any other entity.  Indiana University disclaims any
#  liability to any recipient for claims brought by any other entity
#  based on infringement of intellectual property rights or otherwise.
#
#  LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH
#  NO WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA
#  UNIVERSITY GIVES NO WARRANTIES AND MAKES NO REPRESENTATION THAT
#  SOFTWARE IS FREE OF INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR
#  OTHER PROPRIETARY RIGHTS.  INDIANA UNIVERSITY MAKES NO WARRANTIES THAT
#  SOFTWARE IS FREE FROM "BUGS", "VIRUSES", "TROJAN HORSES", "TRAP
#  DOORS", "WORMS", OR OTHER HARMFUL CODE.  LICENSEE ASSUMES THE ENTIRE
#  RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR ASSOCIATED MATERIALS,
#  AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION GENERATED USING
#  SOFTWARE.
###################################################################


printf "(\n";
while(<ARGV>) {
    if($_ =~ /.*\#pragma\W*opieMatrix\W*\(([^,]*),([^,]*),([^,]*)\)(.*)/) {
	printf "  (matrix-pragma %s %s %s)\n", $1, $2, $3;
    }
    elsif($_ =~ /.*\#pragma\W*simpleIndex\W*\(([^,]*),([^,]*)\)(.*)/) {
	printf "  (index-pragma %s simple %s)\n", $1, $2;
    }
    elsif($_ =~ /.*\#pragma\W*mixedIndex\W*\(([^,]*),([^,]*)\)(.*)/) {
	printf "  (index-pragma %s mixed %s)\n", $1, $2;
    }
}
printf ")\n";
